// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2002                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
//   DLLɂ摜QƂ̃Tv
//
// 쐬 : K.Kotajima
//
//  : 2002/07/10 
//
// -------------------------------------------------------------------

#include <windows.h>
#include "average.h"

/* ------------------------------------------------------------------------
	long WINAPI AreaAverage
		ẅ̉f̕ϔZx߂܂B
		8bitOC摜płB

	
		long lImageAddres	摜̐擪AhX
		long lImageSizeX	摜XTCY
		long lImageSizeY	摜YTCY
		long lImageBPP		摜BPPl
		long lsx	ς߂̈̍XW
		long lsy	ς߂̈̍YW
		long lex	ς߂̈̉EXW
		long ley	ς߂̈̉EYW
	Ԓl
		IF@߂ꂽϔZxl
		ُIF@-1
 ------------------------------------------------------------------------- */
double WINAPI AreaAverage( long lImageAddress, long lImageSizeX, long lImageSizeY, long lImageBPP,
																long lsx, long lsy, long lex, long ley )
{
	unsigned char *pImageTop;
	long i,j;

	double dAverage = 0.0;

	// BPP8ȊOُ͈̎I
	if( lImageBPP != 8 ) return -1;
	
	// n_ƏI_ւĂC
	if( lsx > lex ){
		i = lsx;
		lex = lsx;
		lsx = i;
	}
	if( lsy > ley ){
		i = lsy;
		ley = lsy;
		lsy = i;
	}
	// ẅ悪摜TCY͂ݏoĂȂ`FbNB
	// ͂ݏoĂُI
	if( (lsx < 0) | (lsx >= lImageSizeX) ) return -1;
	if( (lsy < 0) | (lsy >= lImageSizeY) ) return -1;
	if( (lex < 0) | (lex >= lImageSizeX) ) return -1;
	if( (ley < 0) | (ley >= lImageSizeY) ) return -1;

	// 󂯎AhXl|C^
	pImageTop = (unsigned char*)lImageAddress;

	//ϒľvZ
	for( j=lsy; j<ley+1; j++ ){
		for( i=lsx; i<lex+1; i++ ){
			dAverage += *(pImageTop+(j*lImageSizeX)+i);
		}
	}
	dAverage = dAverage / (double)(lex - lsx + 1) / (double)(ley - lsy + 1);
	
	return dAverage;
}
